<template>
  <div class="container-xxl">
    <div class="row mt-5 mt-md-10">
      <div class="col-12 col-md-6 col-lg-6 col-xxl-5">
        <div class="card shadow-sm">
          <div
            v-if="response.mostrar === 'LOADING'"
            class="d-flex justify-content-center py-20"
          >
            <div
              class="spinner-border text-primary"
              style="width: 4rem; height: 4rem; border-width: 0.35rem"
              role="status"
            >
              <span class="visually-hidden">Cargando...</span>
            </div>
          </div>

          <div
            v-else
            class="card-body"
          >
            <div class="row">
              <div class="col-12">
                <div class="d-flex flex-column">
                  <div
                    id="transporte_buscar_carousel"
                    class="carousel carousel-dark slide"
                    data-bs-ride="carousel"
                    data-bs-interval="2000"
                    data-bs-wrap="true"
                  >
                    <div class="carousel-indicators">
                      <button
                        v-for="i in transporte.imagenes.length"
                        :key="i"
                        type="button"
                        data-bs-target="#transporte_buscar_carousel"
                        :data-bs-slide-to="i-1"
                        :class="i === 1 ? 'active' : ''"
                        :aria-current="i === 1"
                        :aria-label="'Slide '+i"
                      />
                    </div>
                    <div class="carousel-inner">
                      <div
                        v-for="(imagen, index) in transporte.imagenes"
                        :key="imagen.id"
                        :class="index === 0 ? 'carousel-item active' : 'carousel-item'"
                      >
                        <img
                          :src="imagen.url"
                          class="d-block h-200px h-md-300px w-100"
                          alt="imagen"
                        >
                      </div>
                    </div>
                    <button
                      class="carousel-control-prev"
                      type="button"
                      data-bs-target="#transporte_buscar_carousel"
                      data-bs-slide="prev"
                    >
                      <span
                        class="carousel-control-prev-icon"
                        aria-hidden="true"
                      />
                      <span class="visually-hidden">Previous</span>
                    </button>
                    <button
                      class="carousel-control-next"
                      type="button"
                      data-bs-target="#transporte_buscar_carousel"
                      data-bs-slide="next"
                    >
                      <span
                        class="carousel-control-next-icon"
                        aria-hidden="true"
                      />
                      <span class="visually-hidden">Next</span>
                    </button>
                  </div>

                  <div class="d-flex align-items-center mt-5">
                    <label
                      class="text-gray-900 fs-1 fw-bolder me-3"
                      v-text="transporte.tipoVehiculo"
                    />
                  </div>
                  <div class="d-flex flex-wrap fw-bold mb-2 fs-4 text-gray-600">
                    <span class="d-flex align-items-center me-5 mb-2">
                      {{ transporte.placa }}
                    </span>
                  </div>

                  <div class="separator border-2 my-2" />

                  <div class="d-flex fs-4 mt-5">
                    <label class="fw-bolder text-dark align-self-center me-2">Dimensiones:</label>
                    <label
                      class="text-gray-800 align-self-center"
                      v-text="transporte.ancho + ' ancho X ' + transporte.largo + ' largo X ' +transporte.alto + ' alto'"
                    />
                  </div>

                  <div class="d-flex fs-4 mt-2">
                    <label class="fw-bolder text-dark align-self-center me-2">Tonelaje:</label>
                    <label
                      class="text-gray-800 align-self-center"
                      v-text="transporte.capacidadTonelada + ' tn'"
                    />
                  </div>

                  <div class="d-flex fs-4 mt-2">
                    <label class="fw-bolder text-dark align-self-center me-2">Conductor:</label>
                    <label
                      class="text-gray-800 align-self-center"
                      v-text="transporte.nombreCompletoChofer"
                    />
                  </div>

                  <div class="d-flex fs-4 mt-2">
                    <label class="fw-bolder text-dark align-self-center me-2">Teléfono:</label>
                    <label
                      class="text-gray-800 align-self-center"
                      v-text="transporte.telefono"
                    />
                  </div>

                  <div class="d-flex flex-column fs-4 mt-2">
                    <label class="fw-bolder text-dark">Propietario:</label>
                    <div class="d-flex  align-items-center mb-3">
                      <div class="d-flex align-items-center flex-grow-1">
                        <div class="symbol symbol-circle symbol-45px me-5">
                          <img
                            :src="transporte.persona.urlFoto"
                            alt="foto"
                          >
                        </div>
                        <router-link
                          :to="{ name: 'panel.usuario.mostrar', params: { id: transporte.persona.id }}"
                          class="text-gray-600 text-hover-primary"
                          v-text="transporte.persona.nombreCompleto"
                        />
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>

      <div class="col-12 col-md-6 col-lg-6 col-xxl-7">
        <div class="card shadow-sm">
          <div class="card-body p-2">
            <div class="row">
              <div class="col-12">
                <GoogleMap
                  api-key="AIzaSyA2XeZf5gGUwUTKl9y-hq2GsMdTlCJCgds"
                  class="h-400px"
                  :center="{lat: transporte.latitud, lng: transporte.longitud}"
                  :zoom="14"
                >
                  <Marker
                    v-if="transporte.latitud"
                    :options="{ position: {lat: transporte.latitud, lng: transporte.longitud}, draggable: false, clickable: false }"
                  />
                </GoogleMap>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import Servicio from "@/core/servicio/Servicio";
import Ruta from "@/core/servicio/Ruta";
import Toast from "@/core/util/Toast";

import { GoogleMap, Marker  } from "vue3-google-map";

export default {
  name: 'TransporteMostrar',
  components: {
    GoogleMap, Marker
  },
  data() {
    return {
      transporte: {},
      response: {mostrar: 'LOADING'}
    }
  },
  mounted() {
    this.onTransporteMostrar();
  },
  methods: {
    onTransporteMostrar() {
      this.response.mostrar = 'LOADING';
      Servicio.get(Ruta.rutaPanelTransporteMostrar(this.$route.params.id)).then( (data) => {
        this.transporte = data.data;
        this.response.mostrar = data.estado;
      }).catch( (error) => {
        this.response.mostrar = 'ERROR';
        Toast.mostrarError(error);
      });
    },
  }
}
</script>
